Index: /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/trasbc.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/trasbc.F90	(revision 2148)
@@ -7,5 +7,6 @@
    !!            8.2  !  2001-02  (D. Ludicone)  sea ice and free surface
    !!  NEMO      1.0  !  2002-06  (G. Madec)  F90: Free form and module
-   !!            3.3  !  2010-09  (C. Ethe, G. Madec) Merge TRA-TRC
+   !!            3.3  !  2010-04  (M. Leclair, G. Madec)  Forcing averaged over 2 time steps
+   !!             -   !  2010-09  (C. Ethe, G. Madec) Merge TRA-TRC
    !!----------------------------------------------------------------------
 
@@ -22,6 +23,8 @@
    USE in_out_manager  ! I/O manager
    USE prtctl          ! Print control
+   USE restart         ! ocean restart
    USE sbcrnf          ! River runoff  
    USE sbcmod          ! ln_rnf  
+   USE iom
 
    IMPLICIT NONE
@@ -103,9 +106,9 @@
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       !!
-      INTEGER  ::   ji, jj, jk      ! dummy loop indices  
-      REAL(wp) ::   zta, zsa        ! local scalars, adjustment to temperature and salinity  
-      REAL(wp) ::   zata, zasa      ! local scalars, calculations of automatic change to temp & sal due to vvl (done elsewhere)  
+      INTEGER  ::   ji, jj, jk           ! dummy loop indices  
+      REAL(wp) ::   zta, zsa, zrnf       ! local scalars, adjustment to temperature and salinity  
       REAL(wp) ::   zsrau, zse3t, zdep   ! local scalars, 1/density, 1/height of box, 1/height of effected water column  
       REAL(wp) ::   zdheat, zdsalt       ! total change of temperature and salinity  
+      REAL(wp) ::   zfact, z1_e3t        ! 
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt, ztrds
       !!----------------------------------------------------------------------
@@ -118,7 +121,4 @@
 
       zsrau = 1. / rau0             ! initialization
-#if defined key_zco
-      zse3t = 1. / e3t_0(1)
-#endif
 
       IF( l_trdtra )   THEN                    !* Save ta and sa trends
@@ -127,35 +127,112 @@
       ENDIF
 
-      IF( .NOT.ln_traqsr )   qsr(:,:) = 0.e0   ! no solar radiation penetration
-
-      ! Concentration dilution effect on (t,s) due to evapouration, precipitation and qns, but not river runoff  
+!!gm      IF( .NOT.ln_traqsr )   qsr(:,:) = 0.e0   ! no solar radiation penetration
+      IF( .NOT.ln_traqsr ) THEN     ! no solar radiation penetration
+         qns(:,:) = qns(:,:) + qsr(:,:)      ! total heat flux in qns
+         qsr(:,:) = 0.e0                     ! qsr set to zero
+      ENDIF
+
+      !                                          Set before sbc tracer content fields
+      !                                          ************************************
+      IF( kt == nit000 ) THEN                      ! Set the forcing field at nit000 - 1
+         !                                         ! -----------------------------------
+         IF( ln_rstart .AND.    &                     ! Restart: read in restart file
+              & iom_varid( numror, 'sbc_hc_b', ldstop = .FALSE. ) > 0 ) THEN
+            IF(lwp) WRITE(numout,*) '          nit000-1 surface tracer content forcing fields red in the restart file'
+            zfact = 0.5e0
+            CALL iom_get( numror, jpdom_autoglo, 'sbc_hc_b', sbc_hc_b )   ! before heat content sbc trend
+            CALL iom_get( numror, jpdom_autoglo, 'sbc_sc_b', sbc_sc_b )   ! before salt content sbc trend
+         ELSE                                         ! No restart or restart not found: Euler forward time stepping
+            zfact = 1.e0
+            sbc_hc_b(:,:) = 0.e0
+            sbc_sc_b(:,:) = 0.e0
+         ENDIF
+      ELSE                                         ! Swap of forcing fields
+         !                                         ! ----------------------
+         zfact = 0.5e0
+         sbc_hc_b(:,:) = sbc_hc_n(:,:)
+         sbc_sc_b(:,:) = sbc_sc_n(:,:)
+      ENDIF
+      !                                          Compute now sbc tracer content fields
+      !                                          *************************************
+
+                                                   ! Concentration dilution effect on (t,s) due to  
+                                                   ! evaporation, precipitation and qns, but not river runoff 
+                                               
+      IF( lk_vvl ) THEN                            ! Variable Volume case
+         DO jj = 2, jpj
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               ! temperature : heat flux + cooling/heating effet of EMP flux
+               sbc_hc_n(ji,jj) = ro0cpr * qns(ji,jj) - zsrau * emp(ji,jj) * tsn(ji,jj,1,jp_tem)
+               ! concent./dilut. effect due to sea-ice melt/formation and (possibly) SSS restoration
+               sbc_sc_n(ji,jj) = ( emps(ji,jj) - emp(ji,jj) ) * zsrau * tsn(ji,jj,1,jp_sal)
+            END DO
+         END DO
+      ELSE                                         ! Constant Volume case
+         DO jj = 2, jpj
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               ! temperature : heat flux
+               sbc_hc_n(ji,jj) = ro0cpr * qns(ji,jj)
+               ! salinity    : salt flux + concent./dilut. effect (both in emps)
+               sbc_sc_n(ji,jj) = zsrau * emps(ji,jj) * tsn(ji,jj,1,jp_sal)
+            END DO
+         END DO
+      ENDIF
+                                                   ! Concentration dilution effect on (t,s) due to  
+                                                   ! river runoff without T, S and depth attributes
+      IF( ln_rnf ) THEN 
+         !
+         IF( lk_vvl ) THEN                            ! Variable Volume case 
+            !                                         ! cooling/heating effect of runoff & No salinity concent./dilut. effect
+            DO jj = 2, jpj
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  sbc_hc_n(ji,jj) = sbc_hc_n(ji,jj) + zsrau * rnf(ji,jj) * tsn(ji,jj,1,jp_tem)
+               END DO
+            END DO
+         ELSE                                         ! Constant Volume case
+            !                                         ! concent./dilut. effect only
+            DO jj = 2, jpj 
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  sbc_sc_n(ji,jj) = sbc_sc_n(ji,jj) - zsrau * rnf(ji,jj) * tsn(ji,jj,1,jp_sal)
+               END DO
+            END DO
+         ENDIF
+         !  
+      ENDIF
+      !                                          Add to the general trend
+      !                                          ************************
       DO jj = 2, jpj
          DO ji = fs_2, fs_jpim1   ! vector opt.
-#if ! defined key_zco
-            zse3t = 1. / fse3t(ji,jj,1)
-#endif
-            IF( lk_vvl) THEN
-               ! temperature : heat flux and heat content of EMP flux
-               zta = ( ro0cpr * qns(ji,jj) - emp(ji,jj) * zsrau * tsn(ji,jj,1,jp_tem) ) * zse3t
-               ! Salinity    : concent./dilut. effect due to sea-ice melt/formation and (possibly) SSS restoration
-               zsa = ( emps(ji,jj) - emp(ji,jj) ) * zsrau * tsn(ji,jj,1,jp_sal) * zse3t
-            ELSE
-               zta =  ro0cpr * qns(ji,jj) * zse3t                         ! temperature : heat flux 
-               zsa =  emps(ji,jj) * zsrau * tsn(ji,jj,1,jp_sal) * zse3t   ! salinity :  concent./dilut. effect 
-            ENDIF
-            tsa(ji,jj,1,jp_tem) = tsa(ji,jj,1,jp_tem) + zta                  ! add the trend to the general tracer trend
-            tsa(ji,jj,1,jp_sal) = tsa(ji,jj,1,jp_sal) + zsa
+            z1_e3t = zfact / fse3t(ji,jj,1)
+            tsa(ji,jj,1,jp_tem) = tsa(ji,jj,1,jp_tem) + ( sbc_hc_b(ji,jj) + sbc_hc_n(ji,jj) ) * z1_e3t
+            tsa(ji,jj,1,jp_sal) = tsa(ji,jj,1,jp_sal) + ( sbc_sc_b(ji,jj) + sbc_sc_n(ji,jj) ) * z1_e3t
          END DO
       END DO
+      !                                          Write in the ocean restart file
+      !                                          *******************************
+      IF( lrst_oce ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'sbc : ocean surface tracer content forcing fields written in ocean restart file ',   &
+            &                    'at it= ', kt,' date= ', ndastp
+         IF(lwp) WRITE(numout,*) '~~~~'
+         CALL iom_rstput( kt, nitrst, numrow, 'sbc_hc_b', sbc_hc_n )
+         CALL iom_rstput( kt, nitrst, numrow, 'sbc_sc_b', sbc_sc_n )
+      ENDIF
 
       IF( ln_rnf .AND. ln_rnf_att ) THEN        ! Concentration / dilution effect on (t,s) due to river runoff  
+        !
         DO jj = 1, jpj  
            DO ji = 1, jpi  
-              zdep = 1. / rnf_dep(ji,jj)  
-              zse3t= 1. / fse3t(ji,jj,1)  
-              IF( rnf_tem(ji,jj) == -999 )   rnf_tem(ji,jj) = tsn(ji,jj,1,jp_tem)   ! if not specified set runoff temp to be sst  
+              zdep  = 1. / rnf_dep(ji,jj)  
+              zse3t = 1. / fse3t(ji,jj,1)  
+              rnf_dep(ji,jj) = 0.e0
+              DO jk = 1, rnf_mod_dep(ji,jj)                          ! recalculates rnf_dep to be the depth  
+                rnf_dep(ji,jj) = rnf_dep(ji,jj) + fse3t(ji,jj,jk)    ! in metres to the bottom of the relevant grid box  
+              END DO
+              IF( rnf_tmp(ji,jj) == -999 )   rnf_tmp(ji,jj) = tsn(ji,jj,1,jp_tem)   ! if not specified set runoff temp to be sst  
   
               IF( rnf(ji,jj) > 0.e0 ) THEN  
-  
+                !
+                zrnf = rnf(ji,jj) * zsrau * zdep
                 IF( lk_vvl ) THEN  
                   ! indirect flux, concentration or dilution effect : force a dilution effect in all levels 
@@ -163,6 +240,6 @@
                   zdsalt = 0.e0  
                   DO jk = 1, rnf_mod_dep(ji,jj)  
-                    zta = -tsn(ji,jj,jk,jp_tem) * rnf(ji,jj) * zsrau * zdep  
-                    zsa = -tsn(ji,jj,jk,jp_sal) * rnf(ji,jj) * zsrau * zdep  
+                    zta = -tsn(ji,jj,jk,jp_tem) * zrnf  
+                    zsa = -tsn(ji,jj,jk,jp_sal) * zrnf  
                     tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + zta        ! add the trend to the general tracer trend
                     tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + zsa
@@ -171,34 +248,25 @@
                   END DO  
                   ! negate this total change in heat and salt content from top level    !!gm I don't understand this
-                  zta = -zdheat * zse3t  
-                  zsa = -zdsalt * zse3t  
-                  tsa(ji,jj,1,jp_tem) = tsa(ji,jj,1,jp_tem) + zta            ! add the trend to the general tracer trend
-                  tsa(ji,jj,1,jp_sal) = tsa(ji,jj,1,jp_sal) + zsa
-    
-                  ! direct flux  
-                  zta = rnf_tem(ji,jj) * rnf(ji,jj) * zsrau * zdep  
-                  zsa = rnf_sal(ji,jj) * rnf(ji,jj) * zsrau * zdep  
+                  tsa(ji,jj,1,jp_tem) = tsa(ji,jj,1,jp_tem) - zdheat * zse3t
+                  tsa(ji,jj,1,jp_sal) = tsa(ji,jj,1,jp_sal) - zdsalt * zse3t
     
                   DO jk = 1, rnf_mod_dep(ji,jj)  
-                    tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + zta        ! add the trend to the general tracer trend
-                    tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + zsa
+                    tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + rnf_tmp(ji,jj) * zrnf
+                    tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + rnf_sal(ji,jj) * zrnf
                   END DO  
                 ELSE  
                   DO jk = 1, rnf_mod_dep(ji,jj)  
-                    zta = ( rnf_tem(ji,jj) - tsn(ji,jj,jk,jp_tem) ) * rnf(ji,jj) * zsrau * zdep  
-                    zsa = ( rnf_sal(ji,jj) - tsn(ji,jj,jk,jp_sal) ) * rnf(ji,jj) * zsrau * zdep  
-                    tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + zta        ! add the trend to the general tracer trend
-                    tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + zsa
+                    tsa(ji,jj,jk,jp_tem) = tsa(ji,jj,jk,jp_tem) + ( rnf_tmp(ji,jj) - tsn(ji,jj,jk,jp_tem) ) * zrnf
+                    tsa(ji,jj,jk,jp_sal) = tsa(ji,jj,jk,jp_sal) + ( rnf_sal(ji,jj) - tsn(ji,jj,jk,jp_sal) ) * zrnf
                   END DO  
                 ENDIF  
   
-              ELSEIF( rnf(ji,jj) < 0.e0) THEN   ! for use in baltic when flow is out of domain, want no change in temp and sal  
+              ELSEIF( rnf(ji,jj) < 0.e0 ) THEN   ! for use in baltic when flow is out of domain, want no change in temp and sal  
   
                 IF( lk_vvl ) THEN  
                   ! calculate automatic adjustment to sal and temp due to dilution/concentraion effect   
-                  zata = tsn(ji,jj,1,jp_tem) * rnf(ji,jj) * zsrau * zse3t  
-                  zasa = tsn(ji,jj,1,jp_sal) * rnf(ji,jj) * zsrau * zse3t  
-                  tsa(ji,jj,1,jp_tem) = tsa(ji,jj,1,jp_tem) + zata                  ! add the trend to the general tracer trend
-                  tsa(ji,jj,1,jp_sal) = tsa(ji,jj,1,jp_sal) + zasa
+                  zrnf = rnf(ji,jj) * zsrau * zse3t
+                  tsa(ji,jj,1,jp_tem) = tsa(ji,jj,1,jp_tem) + tsn(ji,jj,1,jp_tem) * zrnf 
+                  tsa(ji,jj,1,jp_sal) = tsa(ji,jj,1,jp_sal) + tsn(ji,jj,1,jp_sal) * zrnf
                 ENDIF  
   
@@ -207,25 +275,5 @@
            END DO  
         END DO  
-
-      ELSE IF( ln_rnf ) THEN      ! Concentration dilution effect on (t,s) due to runoff without T, S and depth attributes
-
-
-        DO jj = 2, jpj
-           DO ji = fs_2, fs_jpim1   ! vector opt.
-#if ! defined key_zco
-              zse3t = 1. / fse3t(ji,jj,1)
-#endif
-              IF( lk_vvl) THEN
-                 zta =    rnf(ji,jj) * zsrau * tsn(ji,jj,1,jp_tem) * zse3t       ! & cooling/heating effect of runoff
-                 zsa =    0.e0                                                   ! No salinity concent./dilut. effect
-              ELSE
-                 zta =    0.0                                            ! temperature : heat flux 
-                 zsa =  - rnf(ji,jj) * zsrau * tsn(ji,jj,1,jp_sal) * zse3t     ! salinity :  concent./dilut. effect
-              ENDIF
-              tsa(ji,jj,1,jp_tem) = tsa(ji,jj,1,jp_tem) + zta          ! add the trend to the general tracer trend
-              tsa(ji,jj,1,jp_sal) = tsa(ji,jj,1,jp_sal) + zsa
-           END DO
-        END DO
- 
+        !
       ENDIF  
 
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/istate.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/istate.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/istate.F90	(revision 2148)
@@ -67,4 +67,6 @@
       !! ** Purpose :   Initialization of the dynamics and tracer fields.
       !!----------------------------------------------------------------------
+      ! - ML - needed for initialization of e3t_b
+      INTEGER  ::  jk     ! dummy loop indice
 
       IF(lwp) WRITE(numout,*)
@@ -128,5 +130,12 @@
          IF( ln_zps .AND. .NOT. lk_c1d )   CALL zps_hde( nit000, jpts, tsb, gtsu, gtsv,  & ! zps: before hor. gradient
             &                                                          rhd, gru , grv  )   ! of t,s,rd at ocean bottom
-         !    
+         !   
+         ! - ML - sshn could be modified by istate_eel, so that initialization of fse3t_b is done here
+         IF( lk_vvl ) THEN
+            DO jk = 1, jpk
+               fse3t_b(:,:,jk) = fse3t_n(:,:,jk)
+            ENDDO
+         ENDIF
+         ! 
       ENDIF
       !
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/oce.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/oce.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/oce.F90	(revision 2148)
@@ -36,5 +36,5 @@
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sshu_b ,  sshu_n  ,  sshu_a  !: sea surface height at u-point [m]
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sshv_b ,  sshv_n  ,  sshv_a  !: sea surface height at u-point [m]
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   sshf_b ,  sshf_n  ,  sshf_a  !: sea surface height at f-point [m]
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::             sshf_n             !: sea surface height at f-point [m]
    !
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   spgu, spgv                   !: horizontal surface pressure gradient
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/opa.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/opa.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/opa.F90	(revision 2148)
@@ -281,4 +281,5 @@
       IF( lk_diaar5    )    CALL dia_ar5_init   ! ar5 diag
                             CALL dia_ptr_init   ! Poleward TRansports initialization
+                            CALL dia_hsb_init   ! heat content, salt content and volume budgets
                             CALL trd_mod_init   ! Mixed-layer/Vorticity/Integral constraints trends
       !
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/step.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/step.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/step.F90	(revision 2148)
@@ -221,4 +221,6 @@
                                CALL ssh_nxt( kstp )         ! sea surface height at next time step
 
+      IF( ln_diahsb        )   CALL dia_hsb( kstp )         ! - ML - global conservation diagnostics
+
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
       ! Control and restarts
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/step_oce.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/step_oce.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/step_oce.F90	(revision 2148)
@@ -85,4 +85,5 @@
    USE diahth           ! thermocline depth                (dia_hth routine)
    USE diafwb           ! freshwater budget                (dia_fwb routine)
+   USE diahsb           ! heat, salt and volume budgets    (dia_hsb routine)
    USE flo_oce          ! floats variables
    USE floats           ! floats computation               (flo_stp routine)
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/PISCES/p4zmort.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/PISCES/p4zmort.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/PISCES/p4zmort.F90	(revision 2148)
@@ -235,5 +235,5 @@
       !!
       !! ** Method  :   Read the nampismort namelist and check the parameters
-      !!      called at the first timestep (nittrc000)
+      !!      called at the first timestep
       !!
       !! ** input   :   Namelist nampismort
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/PISCES/p4zrem.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/PISCES/p4zrem.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/PISCES/p4zrem.F90	(revision 2148)
@@ -408,5 +408,5 @@
       !!
       !! ** Method  :   Read the nampisrem namelist and check the parameters
-      !!      called at the first timestep (nittrc000)
+      !!      called at the first timestep
       !!
       !! ** input   :   Namelist nampisrem
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/PISCES/p4zsink.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 2148)
@@ -321,5 +321,5 @@
       !!
       !! ** Method  :   Read the nampiskrs namelist and check the parameters
-      !!      called at the first timestep (nittrc000)
+      !!      called at the first timestep 
       !!
       !! ** input   :   Namelist nampiskrs
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcadv.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 2148)
@@ -65,9 +65,9 @@
       !!----------------------------------------------------------------------
 
-      IF( kt == nittrc000 )   CALL trc_adv_ctl          ! initialisation & control of options
+      IF( kt == nit000 )   CALL trc_adv_ctl          ! initialisation & control of options
 
-      IF( neuler == 0 .AND. kt == nittrc000 ) THEN     ! at nit000
+      IF( neuler == 0 .AND. kt == nit000 ) THEN     ! at nit000
          r2dt(:) =  rdttra(:) * FLOAT(nn_dttrc)          ! = rdtra (restarting with Euler time stepping)
-      ELSEIF( kt <= nittrc000 + nn_dttrc ) THEN          ! at nit000 or nit000+1
+      ELSEIF( kt <= nit000 + nn_dttrc ) THEN          ! at nit000 or nit000+1
          r2dt(:) = 2. * rdttra(:) * FLOAT(nn_dttrc)      ! = 2 rdttra (leapfrog)
       ENDIF
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcdmp.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcdmp.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcdmp.F90	(revision 2148)
@@ -82,5 +82,5 @@
       ! 0. Initialization (first time-step only)
       !    --------------
-      IF( kt == nittrc000 ) CALL trc_dmp_init
+      IF( kt == nit000 ) CALL trc_dmp_init
 
       IF( l_trdtrc )   ALLOCATE( ztrtrd(jpi,jpj,jpk) )   ! temporary save of trends
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcldf.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 2148)
@@ -62,5 +62,5 @@
       !!----------------------------------------------------------------------
 
-      IF( kt == nittrc000 )   CALL ldf_ctl          ! initialisation & control of options
+      IF( kt == nit000 )   CALL ldf_ctl          ! initialisation & control of options
 
       IF( l_trdtrc )  THEN 
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcnxt.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 2148)
@@ -86,5 +86,5 @@
       !!----------------------------------------------------------------------
 
-      IF( kt == nittrc000 .AND. lwp ) THEN
+      IF( kt == nit000 .AND. lwp ) THEN
          WRITE(numout,*)
          WRITE(numout,*) 'trc_nxt : time stepping on passive tracers'
@@ -109,6 +109,6 @@
 
       ! set time step size (Euler/Leapfrog)
-      IF( neuler == 0 .AND. kt ==  nittrc000) THEN  ;  r2dt(:) =     rdttra(:) * FLOAT( nn_dttrc )  ! at nit000             (Euler)
-      ELSEIF( kt <= nittrc000 + 1 )           THEN  ;  r2dt(:) = 2.* rdttra(:) * FLOAT( nn_dttrc )  ! at nit000 or nit000+1 (Leapfrog)
+      IF( neuler == 0 .AND. kt ==  nit000) THEN  ;  r2dt(:) =     rdttra(:) * FLOAT( nn_dttrc )  ! at nit000             (Euler)
+      ELSEIF( kt <= nit000 + 1 )           THEN  ;  r2dt(:) = 2.* rdttra(:) * FLOAT( nn_dttrc )  ! at nit000 or nit000+1 (Leapfrog)
       ENDIF
 
@@ -120,6 +120,6 @@
 
       ! Leap-Frog + Asselin filter time stepping
-      IF( lk_vvl ) THEN   ;   CALL tra_nxt_vvl( kt, nittrc000, trb, trn, tra, jptra )      ! variable volume level (vvl) 
-      ELSE                ;   CALL tra_nxt_fix( kt, nittrc000, trb, trn, tra, jptra )      ! fixed    volume level 
+      IF( lk_vvl ) THEN   ;   CALL tra_nxt_vvl( kt, 'TRC', trb, trn, tra, jptra )      ! variable volume level (vvl) 
+      ELSE                ;   CALL tra_nxt_fix( kt,        trb, trn, tra, jptra )      ! fixed    volume level 
       ENDIF
 
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcrad.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 2148)
@@ -54,5 +54,5 @@
       !!----------------------------------------------------------------------
 
-      IF( kt == nittrc000 ) THEN
+      IF( kt == nit000 ) THEN
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) 'trc_rad : Correct artificial negative concentrations '
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 2148)
@@ -65,5 +65,5 @@
       !! * Local declarations
       INTEGER  ::   ji, jj, jn           ! dummy loop indices
-      REAL(wp) ::   ztra, zsrau, zse3t   ! temporary scalars
+      REAL(wp) ::   zsrau, zse3t   ! temporary scalars
       REAL(wp), DIMENSION(jpi,jpj) ::   zemps  ! surface freshwater flux
       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrtrd
@@ -71,5 +71,5 @@
       !!----------------------------------------------------------------------
 
-      IF( kt == nittrc000 ) THEN
+      IF( kt == nit000 ) THEN
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) 'trc_sbc : Passive tracers surface boundary condition'
@@ -82,6 +82,11 @@
 #if ! defined key_offline
       ! Concentration dilution effect on tracer due to evaporation, precipitation, and river runoff
-      IF( lk_vvl ) THEN   ;   zemps(:,:) = emps(:,:) - emp(:,:)   ! volume variable
-      ELSE                ;   zemps(:,:) = emps(:,:) - rnf(:,:)   ! linear free surface 
+      IF( lk_vvl ) THEN                      ! volume variable
+         zemps(:,:) = emps(:,:) - emp(:,:)   
+!!ch         zemps(:,:) = 0.
+      ELSE                                   ! linear free surface
+         IF( ln_rnf ) THEN  ;  zemps(:,:) = emps(:,:) - rnf(:,:)   !  E-P-R
+         ELSE               ;  zemps(:,:) = emps(:,:)
+         ENDIF 
       ENDIF 
 #else
@@ -91,22 +96,15 @@
       ENDIF
 #endif
+
       ! 0. initialization
       zsrau = 1. / rau0
-#if defined key_zco
-      zse3t = 1. / e3t_0(1)
-#endif
-
       DO jn = 1, jptra
          !
          IF( l_trdtrc ) ztrtrd(:,:,:) = tra(:,:,:,jn)  ! save trends
-
+         !                                             ! add the trend to the general tracer trend
          DO jj = 2, jpj
             DO ji = fs_2, fs_jpim1   ! vector opt.
-#if ! defined key_zco 
                zse3t = 1. / fse3t(ji,jj,1)
-#endif
-               ! add the trend to the general tracer trend
-               ztra = zemps(ji,jj) *  zsrau * trn(ji,jj,1,jn) * zse3t
-               tra(ji,jj,1,jn) = tra(ji,jj,1,jn) + ztra
+               tra(ji,jj,1,jn) = tra(ji,jj,1,jn) + zemps(ji,jj) *  zsrau * trn(ji,jj,1,jn) * zse3t
             END DO
          END DO
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trczdf.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 2148)
@@ -61,10 +61,10 @@
       !!---------------------------------------------------------------------
 
-      IF( kt == nittrc000 )   CALL zdf_ctl          ! initialisation & control of options
+      IF( kt == nit000 )   CALL zdf_ctl          ! initialisation & control of options
 
 #if ! defined key_pisces
-      IF( neuler == 0 .AND. kt == nittrc000 ) THEN     ! at nit000
+      IF( neuler == 0 .AND. kt == nit000 ) THEN     ! at nit000
          r2dt(:) =  rdttra(:) * FLOAT(nn_dttrc)          ! = rdtra (restarting with Euler time stepping)
-      ELSEIF( kt <= nittrc000 + nn_dttrc ) THEN          ! at nit000 or nit000+1
+      ELSEIF( kt <= nit000 + nn_dttrc ) THEN          ! at nit000 or nit000+1
          r2dt(:) = 2. * rdttra(:) * FLOAT(nn_dttrc)      ! = 2 rdttra (leapfrog)
       ENDIF
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trdmld_trc.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 2148)
@@ -361,12 +361,5 @@
       !!----------------------------------------------------------------------
 
-      IF( llwarn ) THEN                                           ! warnings
-         IF(      ( nittrc000 /= nit000   ) &
-              .OR.( nn_dttrc    /= 1        )    ) THEN
-
-            WRITE(numout,*) 'Be careful, trends diags never validated'
-            STOP 'Uncomment this line to proceed'
-         ENDIF
-      ENDIF
+      IF( nn_dttrc  /= 1  ) CALL ctl_stop( " Be careful, trends diags never validated " )
 
       ! ======================================================================
@@ -422,5 +415,5 @@
       ! II.1 Set before values of vertically averages passive tracers
       ! -------------------------------------------------------------
-      IF( kt > nittrc000 ) THEN
+      IF( kt > nit000 ) THEN
          DO jn = 1, jptra
             IF( ln_trdtrc(jn) ) THEN
@@ -507,5 +500,5 @@
       tmltrd_trc(:,:,:,:) = tmltrd_trc(:,:,:,:) * rn_ucf_trc
 
-      itmod = kt - nittrc000 + 1
+      itmod = kt - nit000 + 1
       it    = kt
 
@@ -915,12 +908,5 @@
       !!----------------------------------------------------------------------
       ! ... Warnings
-      IF( llwarn ) THEN
-         IF(      ( nittrc000 /= nit000   ) &
-              .OR.( nn_dttrc    /= 1        )    ) THEN
-
-            WRITE(numout,*) 'Be careful, trends diags never validated'
-            STOP 'Uncomment this line to proceed'
-         END IF
-      END IF
+      IF( nn_dttrc  /= 1  ) CALL ctl_stop( " Be careful, trends diags never validated " )
 
       ! ======================================================================
@@ -1038,5 +1024,5 @@
 
       ! define time axis
-      itmod = kt - nittrc000 + 1
+      itmod = kt - nit000 + 1
       it    = kt
 
@@ -1318,5 +1304,5 @@
             CALL dia_nam( clhstnam, nn_trd_trc, csuff )
             CALL histbeg( clhstnam, jpi, glamt, jpj, gphit,                                            &
-               &        1, jpi, 1, jpj, nittrc000-nn_dttrc, zjulian, rdt, nh_t(jn), nidtrd(jn), domain_id=nidom )
+               &        1, jpi, 1, jpj, nit000, zjulian, rdt, nh_t(jn), nidtrd(jn), domain_id=nidom )
       
             !-- Define the ML depth variable
@@ -1331,5 +1317,5 @@
           CALL dia_nam( clhstnam, nn_trd_trc, 'trdbio' )
           CALL histbeg( clhstnam, jpi, glamt, jpj, gphit,                                            &
-             &             1, jpi, 1, jpj, nittrc000-nn_dttrc, zjulian, rdt, nh_tb, nidtrdbio, domain_id=nidom )
+             &             1, jpi, 1, jpj, nit000, zjulian, rdt, nh_tb, nidtrdbio, domain_id=nidom )
 #endif
 
Index: /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trdmod_trc.F90
===================================================================
--- /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trdmod_trc.F90	(revision 2147)
+++ /branches/DEV_r2106_LOCEAN2010/NEMO/TOP_SRC/TRP/trdmod_trc.F90	(revision 2148)
@@ -50,5 +50,5 @@
       !!----------------------------------------------------------------------
 
-      IF( kt == nittrc000 ) THEN
+      IF( kt == nit000 ) THEN
 !         IF(lwp)WRITE(numout,*)
 !         IF(lwp)WRITE(numout,*) 'trd_mod_trc:'
